Subject: RE: bug#16038: 24.3; latest change to with-help-window makes temp-buffer-browse useless

From: Drew Adams <[email-masked]>
Date: Sat, 25 Jan 2014 12:19:46 -0800 (PST)

>  > -- is bug #8368 fixed?
> 
> I don't know and I don't care.

That's too bad.  Especially for someone who participated actively
in that thread and proposed (it seemed) a solution for it, to
which Stefan seemed to give the go-ahead.  Sorry you feel that way.

> I almost forgot about it until you decided to participate in the
> present thread.

I'm glad that my participation reminded you of #8368, and you then
brought it into this discussion.  You were right to do so.  It is
relevant - not just the bug but the discussion thread.

>  > If you have a concrete suggestion, please offer it.
>  > And what is the "problem" that needs fixing with my not having
>  > any code that uses `with-temp-buffer-window'?
> 
> The one you apparently have with `with-output-to-temp-buffer'.

And just what problem is that?  You say there is a problem to
fix in my code.  What is the problem?  (And what is the fix you
have in mind?)

>  > If bug #8368 is now fixed, great: What code to replace with what
>  > code, concretely?
> 
> Your code that uses `with-output-to-temp-buffer'.

Why should that be replaced?  And if it should, just what should
it to be replaced with?  That is part of deprecating something:
tell users what they should change to what in existing code. E.g.,

(old-foo this that) ==>
  (new-bar something-else that 42 (1- this))

or whatever.

>  > Are the misnamed macros and hooks being renamed as well?
>  >
>  > I don't see that in the doc string of `with-temp-buffer-window'.
>  > If a macro and the hooks it uses are all about *Help* then they
>  > should not be named `with-output-to-temp-buffer',
>  > `temp-buffer-setup-hook' etc.  They should have "help" in their
>  > names instead of "temp".   ===> bug #8368.
>  >
>  > Adding new hooks that have almost the same names but very different
>  > meanings and uses is a bad idea.  `temp-buffer-window-setup-hook'
>  > and `temp-buffer-setup-hook' sound like they would be similar, with
>  > the difference being "window".  Alas no.
>  >
>  > I don't have a problem with your new names.  The problem is with
>  > the old names, and with not deprecating them, _especially_ after
>  > adding false-friend new names.
>  >
>  > The old macros and hooks should be renamed to use "help" - with
>  > aliases provided for the old names, with deprecation of the old
>  > names, and preferably with no plan to _ever_ desupport the old
>  > names.  (Deprecation does not imply desupport.  It allows for
>  > later desupport, but in some cases desupport is not possible or
>  > advisable or necessary.)
> 
> Maybe Leo would have started to do that if you had not interfered.
> I suggest you apologize and consult with him on how to proceed on
> this matter.

Suggest all you want, if it makes you feel better.  But I do not
feel that I interfered in any way.  Nor do I think I have anything
to apologize for.  But you are welcome to apologize to me for
suggesting that I have done something wrong and have something to
apologize for. ;-)

There might be some incomplete or incoherent changes that still
need fixing or finishing.  Dunno.  But if so, none of those are
my doing.  And in spite of that state, no, I would not think of
asking you or anyone else for an apology for that.  People do
their best, whether or not what they do is TRT or sufficient.

On the contrary - to the extent that things will be improved,
bravo and thank you, to you, Leo, or whomever.  To the extent
that that is not so, or only partly so, I hope that the job
can be finished as mentioned in bug #8368.
 
>  > FWIW, the NEWS is, I would think, one good place to put
>  > deprecation notices.  If `with-output-to-temp-buffer' is
>  > deprecated, we should learn in the NEWS that this is the case
>  > AND what it is replaced by. IOW, tell users how to update their
>  > code.  Likewise for the misnamed hooks etc.
>  >
>  > Instead, at least so far, NEWS has only this:
>  >
>  >   *** New macro `with-temp-buffer-window', similar to
>  >   `with-output-to-temp-buffer'.
>  >
>  > That "similar to" might do more harm than help.
> 
> That's life.

It is neither fate nor accident, but the result of someone's
doing.  See above, about people doing their best whether or
not it is sufficient.  Yes, that is part of life.